<?php 
// dump all nodes

require dirname(__FILE__) . DIRECTORY_SEPARATOR . 'common.inc';

$mecab = mecab_new($arg);

function call_format($node)
{
    return format(mecab_node_get_surface($node), mecab_node_get_feature($node),
                    mecab_node_get_id($node), mecab_node_get_stat($node));
}

if ($node = mecab_sparse_tonode($mecab, $str)) {
    border();
    do {
        $ar = array(
            'node' => mecab_node_toarray($node),
            'prev' => '-',
            'next' => '-',
            'enext' => '-',
            'bnext' => '-',
            'rpath' => '-',
            'lpath' => '-',
        );
        if ($prev = mecab_node_get_prev($node)) {
            $ar['prev'] = call_format($prev);
        }
        if ($next = mecab_node_get_next($node)) {
            $ar['next'] = call_format($next);
        }
        if ($enext = mecab_node_get_enext($node)) {
            $ar['enext'] = call_format($enext);
        }
        if ($bnext = mecab_node_get_bnext($node)) {
            $ar['bnext'] = call_format($bnext);
        }
        if ($rpath = mecab_node_get_rpath($node)) {
            $ar['rpath'] = array(
                'prob' => mecab_path_get_prob($rpath),
                'cost' => mecab_path_get_cost($rpath),
                'rnode' => '-',
                'lnode' => '-',
            );
            if ($rpath_rnode = mecab_path_get_rnode($rpath)) {
                $ar['rpath']['rnode'] = call_format($rpath_rnode);
            }
            if ($rpath_lnode = mecab_path_get_lnode($rpath)) {
                $ar['rpath']['lnode'] = call_format($rpath_lnode);
            }
        }
        if ($lpath = mecab_node_get_lpath($node)) {
            $ar['lpath'] = array(
                'prob' => mecab_path_get_prob($lpath),
                'cost' => mecab_path_get_cost($lpath),
                'rnode' => '-',
                'lnode' => '-',
            );
            if ($lpath_rnode = mecab_path_get_rnode($lpath)) {
                $ar['lpath']['rnode'] = call_format($lpath_rnode);
            }
            if ($lpath_lnode = mecab_path_get_lnode($lpath)) {
                $ar['lpath']['lnode'] = call_format($lpath_lnode);
            }
        }
        print_r($ar);
        border();
    } while (mecab_node_next($node));
}

mecab_destroy($mecab);

?>
